;****************************************************************

; Copyright (c)	1985 by	Dave McWherter

; This a simple	print application that just reads a text file
; and sends it as ASCII	codes to the serial printer driver.

;It also shows off some	of the features	of the new McAsm assembler
;and McLink linker. (That means	that this file can't be	assembled
;by MDS	or MACASM, but at least	the structure of the program and
;the code itself is a useful example.) McAsm is	available from me
;directly at the following address:

; Author: Dave McWherter - 70057,1612
;	  2151 Brown Ave.
;	  Bensalem, PA 19020
;	  215-639-8764

;****************************************************************

; File = LIST.ASM

	title	"File lister application   $"	timestamp in title
	name	LIST		our module ID
	prtr	"/E/$45"	set Imagewriter	for ELITE

;****************************************************************
;Configure our application file:

	ftype	'APPL'		file type
	fsign	'List'		file signature
	a5off	$100		start a5 offset	data $100 below	a5

;****************************************************************
;Assembly setup	stuff:

	mexp	0		don't expand macros
	texp	0		don't expand text statements

;****************************************************************
;Include traps definitions (with listing turned	off):
	list	0
	
	incl	"trapdef.asm"

	list	1

;****************************************************************
; Structure of File Manager parameter block:

		dsec	0
ioLink		ds.l	1	queue link in header
ioType		ds.w	1	type for safety	check
ioTrap		ds.w	1	the trap
ioCmdAddr	ds.l	1	address	to dispatch to

ioCompletion	ds.l	1	completion routine
ioResult	ds.w	1	I/O result code
ioFileName	ds.l	1	file name pointer
ioVRefNum	equ	*	volume refnum
ioDrvNum	ds.w	1	drive number
ioRefNum	ds.w	1	file reference number

csCode		equ	*	control/status code [word]
ioFileType	ds.b	1	specified along	with FileName
ioPermssn	ds.b	1	permissions

csParam		equ	*	operation-defined parameters [20 bytes]
ioOwnBuf	ds.l	1	"private" 522-byte buffer

ioBuffer	ds.l	1	data buffer
ioByteCount	ds.l	1	requested byte count
ioNumDone	ds.l	1	actual byte count completed

ioPosMode	ds.w	1	initial	file positioning mode/eol char
ioPosOffset	ds.l	1	file position offset
		dend

ioFQElSize	equ	$50	length of I/O parameter	block

;These are all used as indexes off of A0, so if	we 'BASE' them we
;don't have to type the	'(a0)'.	In other words,	'clr.w ioDrvNum'
;will be equivalent to 'clr.w ioDrvNum(a0)'.

	base	a0,ioLink,ioType,ioTrap,ioCmdAddr
	base	a0,ioCompletion,ioResult,ioFileName
	base	a0,ioVRefNum,ioDrvNum,ioRefNum,csCode
	base	a0,ioFileType,ioPermssn,csParam,ioOwnBuf
	base	a0,ioBuffer,ioByteCount,ioNumDone
	base	a0,ioPosMode,ioPosOffset

;****************************************************************
;This is our variable storage area off of A5:

		a5sec		start of a5 offset data
DiskParms	equ	*	disk I/O parameter block:
		ds.b	IOFQElSize

PrtOutParms	equ	*	printer	I/O parameter block:
		ds.b	IOFQElSize

ByteBuffer	ds.b	1	a one-byte buffer
		ds.b	1	align to even boundary for next:

EventRecord	equ	*	GetNextEvent's result:
EventType	ds.w	1
EventMessage	ds.l	1
EventTime	ds.l	1
EventLocation	ds.l	1
EventModifiers	ds.w	1

WindowPtr	ds.l	1	FindWindow's result

MenuHandle	ds.l	1
MenuItem	ds.w	1

SFReply		equ	*	reply record from Std File package:
SFGood		ds.b	1
SFCopy		ds.b	1
SFType		ds.b	4
SFVRefNum	ds.w	1
SFVersion	ds.w	1
SFName		ds.b	64

ItemHit		ds.w	1	Dialog item hit	result

DialogPtr	ds.l	1	Dialog's pointer
DStorage	ds.w	$AA	Dialog's storage area
ItemHandle	ds.l	1	a dialog item's	handle
ItemType	ds.w	1	a dialog item's	type
ItemBox		ds.b	8	a dialog item's	rectangle

DeskName	ds.w	16	name of	desk accessory selected

NewStyle	ds.w	1	the newly selected style no.
NewOption	ds.w	1	the newly selected option no.
Column		ds.w	1	current	column no.
PageLines	ds.w	1	no. of lines printed on	a page

		a5end

;All of	these are indexed by A5. Since we defined them in an
;'A5SEC', the assembler	will automatically add the '(a5)' to
;these variables everytime we use them.	In other words,
;'lea Diskparms,a0' will be equivalent to 'lea DiskParms(a5),a0'.

;****************************************************************
; Start	up by initializing the managers:

	loc
Start	pea	-4(a5)		space For Quickdraw's use
	_InitGraf		initialize QuickDraw
	_InitFonts		initialize Font	Manager
	_InitWindows		initialize Window Manager
	_InitMenus		initialize Menu	Manager

	clr.l	-(sp)		put zero on stack for restart procecdure
	_InitDialogs		initialize Dialog Manager
	_TEInit			initialize Text	Edit

;Set up	our menus:

	moveq	#1,d1		install	our Apple menu
	bsr	InstallMenu
	move.l	d1,-(sp)	new menu handle	to stack
	move.l	#'DRVR',-(sp)	add desk accessories to	the Apple menu

	_AddResMenu

	moveq	#2,d1		install	our File menu
	bsr	InstallMenu

	moveq	#3,d1		install	our Style menu
	bsr	InstallMenu

	moveq	#4,d1		install	our Options menu
	bsr	InstallMenu

	_DrawMenuBar		draw the new menu bar

;Other misc. initialization:

	move.l	#$0000FFFF,d0	flush all pending events

	_FlushEvents
	_InitCursor		init cursor to arrow

;Clear out our I/O device control blocks:

	lea	DiskParms,a0
	move.w	#IOFQElSize*2-1,d0
.clr	clr.b	(a0)+
	dbra	d0,.clr

;****************************************************************
; Main event loop:

WaitForEvent
	_SystemTask		update disk accessories	often

;Get any waiting events:

	clr.w	-(sp)		clear space for	function result
	move.w	#$FFFF,-(sp)	look for any event
	pea	EventRecord	where to put event result
	_GetNextEvent		any waiting events ?
	move.w	(sp)+,d0
	beq	WaitForEvent	nope - keep looping

	move.w	EventType,d0	is it mouse down ?
	cmp.w	#1,d0
	bne	WaitForEvent	no - ignore whatever
	bra.s	MouseDown	yes - go handle	it

;****************************************************************
; Common exit routine from menu	selections:

SelectionExit
	bsr	UnhighlightMenu	unhighlight selected menu title
	bra	WaitForEvent

;****************************************************************
; Find out where the mouse is down at:

MouseDown
	clr.w	-(sp)		make space for integer result
	move.l	EventLocation,-(sp)	;pass mouse point
	pea	WindowPtr	where to store result window ptr
	_FindWindow		find window where mouse	was
	move.w	(sp)+,d0	get result off stack

	cmpi.b	#2,d0		in a system window ?
	beq	SystemWindow	yes
	cmpi.b	#1,d0		in the menu bar	?
	bne	WaitForEvent	no - ignore it

;****************************************************************
; Mouse	was pressed in the Menu	Bar:

MenuBar
	clr.l	-(sp)		make space for function	result
	move.l	EventLocation,-(sp)	;pass mouse loc as parameter
	_MenuSelect		menu item selected ?
	move.w	(sp)+,d1	   maybe - pop menu ID
	move.w	(sp)+,d2		   and menu item number
	move.w	d2,MenuItem	save menu item no.

	cmpi.w	#1,d1		branch based on	which menu
	beq.s	AppleMenu
	cmpi.w	#2,d1
	beq	FileMenu
	cmpi.w	#3,d1
	beq	StyleMenu
	cmpi.w	#4,d1
	beq	OptionMenu
	bra	WaitForEvent	ignore if not a	menu we	know

; ****************************************************************
;  Handle a selection in	Apple menu:

AppleMenu
	cmpi.w	#1,d2		is it About ?
	beq	About		yes

;Else it must be a desk accessory menu	item:

	moveq	#1,d1		get handle to Menu 1
	bsr	GetMenuHandle
;				menu handle is	on stack
	move.w	MenuItem,-(sp)	also pass menu's item no.
	pea	DeskName	where to put result text
	_GetItem		get desk accessory name (menu text)

	clr.w	-(sp)		make space for	function result
	pea	DeskName	pass desk acc.	name as	param
	_OpenDeskAcc		open the desk acc.
	move.w	(sp)+,d0	clear result from stack
	bra	SelectionExit

;****************************************************************
; User	has selected our 'About...' menu item:

About
	clr.l	-(sp)		 make space for	dialog handle result
	move.w	#1,-(sp)	 get dialog no.	1 from resc file
	pea	Dstorage
	move.l	#-1,-(sp)	 put it	in front of all	other windows

	_GetNewDialog
;				 rtns dialog ptr on stack
	move.l	(sp),-(sp)	 we'll need the	ptr again later
	_SetPort		 make the dialog the current port

	clr.l	-(sp)		 no filter procedure
	pea	ItemHit		where to store	result
	_ModalDialog		 handle	events in the dialog box

;				 (dialog ptr is	on stack)
	_CloseDialog		 whatever the hit was, close it
	bra	SelectionExit

;****************************************************************
; Handle a selection in our File menu:

FileMenu
	cmpi.w	#1,d2		 is it Listing ?
	beq	Listing		yes
	cmpi.w	#2,d2		 is it Quit ?
	beq	Quit		 yes
	bra	WaitForEvent	 should	never happen

;****************************************************************
 ; User	has selected 'Listing':

	loc
Listing

;Use the standard dialog box to get the filename:

	move.w	#80,-(sp)	 where to put dialog box
	move.w	#80,-(sp)
	pea	NulStr		 docs say not needed, but I can't
;				   get it to work without a string!
	clr.l	-(sp)		 no filter proc
	move.w	#-1,-(sp)	 display all file types
	clr.l	-(sp)		 no type table
	clr.l	-(sp)		 no dialog hook
	pea	SFReply	 where to put reply result
	move.w	#2,-(sp)	 selector for SFGetFile
	_Pack3			    in package 3

	move.b	SFGood,d0	 did they cancel it ?
	beq	.Exit	 yes

;Open the file:

	lea	DiskParms,a0	 setup ptr to I/O parameter block
	lea	SFName,a1	 setup ptr to the name
	move.l	a1,ioFileName
	move.w	SFVRefNum,ioVRefNum	 setup vol refnum

	move.b	#1,ioPermssn	 read only permission

	_Open			 open the file
	tst.w	d0		 successful open ?
	bne	.Exit		 no

;Open the serial output driver:

	lea	PrtOutParms,a0
	move.w	PortNum,d0	 which port ?
	cmpi.w	#2,d0
	beq.s	.PortB	 B

.PortA	lea	AOutStr,a1
	bra.s	.Open

.PortB	lea	BOutStr,a1

.Open	move.l	a1,ioFileName
	_Open
	tst.w	d0		 successful open ?
	bne.s	.Close		 no

	bsr	DisplayAbortBox	 display the abort/pause dialog
	bsr	StyleToPrinter	 send style escape codes to printer
	clr.w	Column		 init column no.

NewPage	clr.w	PageLines	 init page line	counter

.Loop	_SystemTask		 update	desk accessories often
	bsr	CheckAbort	 check for abort or pause
	bcs.s	.Done2		 is abort - quit

	bsr	ReadByte	 read bytes
	bcs.s	.Done		 until eof or error
	bsr	PrintChar

	move.w	Paging,d0	 pagination on ?
	beq	.Loop		 no
	move.w	PageLines,d0	 end of	page yet ?
	cmpi.w	#60,d0
	bls	.Loop		 no

	move.b	#$0C,d1	 yes - skip to next page
	bsr	PrintChar
	bra	NewPage

.Done	move.w	Paging,d0	 pagination on ?
	beq.s	.Done2		 no
	move.b	#$0C,d1	 yes - send formfeed to	printer
	bsr	PrintChar

.Done2	move.w	ImageWriter,d0	 is it an ImageWriter ?
	beq.s	.Close		 no
	move.b	#$1B,d1	 yes - reset it
	bsr	PrintChar
	move.b	#$63,d1
	bsr	PrintChar
	bsr	CloseAbortBox	 close the abort/pause dialog

.Close	lea	DiskParms,a0	 close the file
	_Close
;
;*** --> the Driver Manual says you shouldn't Close the serial	driver
;*** --> and it's correct - the system	hangs if you do!

.Exit	bra	SelectionExit


NulStr	text	#" "
AOutStr text	#".AOut"
BOutStr text	#".BOut"
	align

;****************************************************************
; User	wants to quit:

Quit	bsr	UnhighlightMenu	unhighlight the File title
	rts			 return	to the Finder

;****************************************************************
; Handle a selection in our Style menu:

StyleMenu
	move.w	d2,NewStyle	 save newly selected style
	moveq	#3,d1		 get handle for	the style menu
	bsr	GetMenuHandle
;				 leaves	handle on stack
	move.w	NewStyle,d1	 is it ImageWriter item	?
	cmp.w	#1,d1
	beq.s	IWItem		 yes - special

	move.l	(sp),-(sp)	 copy of handle	for later
	move.w	StyleNum,-(sp)	 remove	check from previous style
	clr.w	-(sp)		 FALSE for no check
	_CheckItem
;				 handle	is on stack
	move.w	NewStyle,-(sp)	 put check mark	on new selection
	move.w	#$FFFF,-(sp)	 TRUE for a check
	_CheckItem

	lea	StyleNum,a0	 update	current	style no.
	move.w	NewStyle,(a0)
	bra	SelectionExit

;Handle ImageWriter selection:

IWItem	lea	ImageWriter,a0	 get current ImageWriter state
	move.w	(a0),d1
	not.w	d1		 invert	it
	move.w	d1,(a0)	 save new state
	move.w	#1,-(sp)	 the item no. of ImageWriter
	move.w	d1,-(sp)	 check/uncheck it
	_CheckItem

;Enable/Disable style items:

	moveq	#3,d1		 get the menu handle
	bsr	GetMenuHandle
	move.l	(sp)+,MenuHandle	 save it
	moveq	#3,d3		 init to first style item

IWLoop	move.l	MenuHandle,-(sp)	 pass the handle
	move.w	d3,-(sp)		 and the item no.
	move.w	ImageWriter,d0	 enabling or disabling ?
	bne.s	IW2		 enabling

	_DisableItem		 else disabling
	bra.s	IW4

IW2	_EnableItem

IW4	addq.w	#1,d3		 to next style item
	cmpi.w	#11,d3		 until all styles done
	blt	IWLoop

	bra	SelectionExit

;****************************************************************
; Handle a selection in our Options menu:

OptionMenu
	move.w	d2,NewOption	 save new option selection no.
	cmpi.w	#3,d2		 is it a port option ?
	bge.s	OptionLF	 no

OptionPort
	moveq	#4,d1		 get handle for	option menu
	bsr	GetMenuHandle
;				 handle	is on stack
	move.l	(sp),-(sp)	 another copy of handle	for later
	move.w	PortNum,-(sp)	 uncheck the old port selection
	clr.w	-(sp)
	_CheckItem
;				 handle	still on stack
	move.w	NewOption,-(sp)	check the new port selection
	move.w	#$FFFF,-(sp)
	_CheckItem

	lea	PortNum,a0	 save new port no.
	move.w	NewOption,(a0)
	bra	SelectionExit	 and done

OptionLF
	cmpi.w	#6,d2		 is it a LF option ?
	bge	OptionPage	 no
	moveq	#4,d1		 get handle for	option menu
	bsr	GetMenuHandle	   returns it on the stack
	move.w	NewOption,d0	 the menu's item no.
	move.w	d0,-(sp)
	lea	AddLF-8,a0	 get current state of this option
	lsl.w	#1,d0
	move.w	(a0,d0.w),d3
	not.w	d3		 invert	it
	move.w	d3,(a0,d0.w)	 update	new state
	move.w	d3,-(sp)	 flag to check/uncheck
	_CheckItem
;
	moveq	#4,d1		 get handle on stack again
	bsr	GetMenuHandle
	move.w	NewOption,d1	 setup opposite	option in d2
	moveq	#5,d2		 assume	we're on 4
	cmpi.w	#4,d1		 correct assumption ?
	beq.s	LF2		 yes
	moveq	#4,d2		 no - on 5, opposite is	4

LF2	move.w	d2,-(sp)	 opposite item no. to enable/disable
	tst.w	d3		 checking or unchecking	?
	bne.s	LF4		 checking

	_EnableItem		 unchecking, enable opposite option
	bra.s	LF6

LF4	_DisableItem		 checking, disable opposite option

LF6	bra	SelectionExit

OptionPage
	cmpi.w	#7,d2		 is it pagination option ?
	bne.s	OptionTab	 no
	moveq	#4,d1		 get the menu handle on	stack
	bsr	GetMenuHandle
	move.w	#7,-(sp)	 the menu item no.
	lea	Paging,a0	 get current pagination	state
OptionPage2
	move.w	(a0),d0
	not.w	d0		 invert	it
	move.w	d0,(a0)	 save new state
	move.w	d0,-(sp)	 check/uncheck the item
	_CheckItem
	bra	SelectionExit

OptionTab
	moveq	#4,d1		 get the menu handle on	stack
	bsr	GetMenuHandle
	move.w	#9,-(sp)	 the menu item no.
	lea	Tabbing,a0	 get current tabbing state
	bra	OptionPage2	 then same as pagination

;****************************************************************
; The mouse was pressed in a system window:

SystemWindow
	pea	EventRecord	 just pass the event to	the system
	move.l	WindowPtr,-(sp)
	_SystemClick
	bra	WaitForEvent

;****************************************************************
; Display our abort dialog box:

DisplayAbortBox
	clr.l	-(sp)		 make space for	dialog handle result
	move.w	#2,-(sp)	 get the dialog	from resc file
	pea	Dstorage
	move.l	#-1,-(sp)	 put it	in front of all	other windows

	_GetNewDialog

	move.l	(sp),DialogPtr	 save its ptr
	_SetPort		 make the dialog the current port

;Deactivate the resume	control:

	moveq	#3,d1		 get a handle to resume	item's control
	bsr	GetItemHandle
	move.w	#255,-(sp)	 deactivate the	item
	_HiliteControl
	rts

;****************************************************************
; Check for abort actions:
;   R:	carry set if abort

CheckAbort
	bsr	TestAbortEvent	 any events in our abort dialog	?
	beq.s	CAOK		 nope
	cmpi.w	#1,d1		 is it an abort	?
	beq.s	Abort		 yes - flag it
	cmpi.w	#2,d1		 is it pause ?
	bne.s	CAOK		 no (should never happen)

 ;Handle the pause request:

	moveq	#2,d1		 deactivate the	pause control
	bsr	GetItemHandle
	move.w	#255,-(sp)
	_HiliteControl

	moveq	#3,d1		 activate the resume control
	bsr	GetItemHandle
	clr.w	-(sp)
	_HiliteControl

PauseLoop
	bsr	TestAbortEvent	 wait for an event in our abort	box
	beq	PauseLoop
	cmpi.w	#1,d1		 is it abort ?
	beq.s	Abort		 yes

;Else it must be resume:

	moveq	#3,d1		 deactivate the	resume control
	bsr	GetItemHandle
	move.w	#255,-(sp)
	_HiliteControl

	moveq	#2,d1		 activate the pause control
	bsr	GetItemHandle
	clr.w	-(sp)
	_HiliteControl

CAOK	or	d0,d0		 clear carry for no abort
	rts

Abort	ori.b	#1,CCR		 set carry for abort
	rts

;****************************************************************
; Close the abort dialog box:

CloseAbortBox
	move.l	DialogPtr,-(sp)
	_CloseDialog
	rts

;****************************************************************
; Test	for an event in	our abort/pause	dialog box:
;   R:	equal set if no	events
;	d1.w = dialog box item no. which caused	any event

	loc
TestAbortEvent
	clr.w	-(sp)		 clear space for function result
	move.w	#$FFFF,-(sp)	 look for any event
	pea	EventRecord	 where to put event result
	_GetNextEvent		 any waiting events ?
	move.w	(sp)+,d0
	beq.s	.Exit		 nope

	clr.w	-(sp)		 is the	event in a dialog box ?
	pea	EventRecord
	_IsDialogEvent
	move.w	(sp)+,d0
	beq	.Exit		 no

	clr.w	-(sp)		 is it a hit in	our dialog ?
	pea	EventRecord
	pea	DialogPtr
	pea	ItemHit
	_DialogSelect
	move.w	(sp)+,d0
	beq.s	.Exit		 no

	move.w	ItemHit,d1	 yes - rtn item	no., clr equal

.Exit	rts

;****************************************************************
; Get a handle	to a control item in the abort dialog box:
;   P:	d1.w = the item	no.
;   R:	the handle on the stack

GetItemHandle
	move.l	DialogPtr,-(sp)
	move.w	d1,-(sp)
	pea	ItemType
	pea	ItemHandle
	pea	ItemBox
	_GetDItem

	move.l	(sp)+,a0	   ;get	the rtn	address
	move.l	ItemHandle,-(sp)	;return the handle on the stack
	jmp	(a0)

;****************************************************************
; Send	the style escape codes to the printer:

	loc
StyleToPrinter
	move.w	ImageWriter,d0	 no style choice if not	ImageWriter
	beq.s	.Exit

	move.b	#$1B,d1		the escape code
	bsr	PrintChar
	lea	StyleEscapes-3,a0	;the escape	code table
	move.w	StyleNum,d1	 current style no.
	move.b	(a0,d1.w),d1	 get the style eecape code
	bsr	PrintChar

.Exit	rts

;****************************************************************
; Install a new menu from resource file:
;   P:	d1.w = menu ID
;   R:	d1.l = menu handle

InstallMenu
	bsr	GetMenuHandle	 get the menu's	handle
	move.l	(sp),-(sp)	 make another stack copy of handle
	clr.w	-(sp)		 beforeID = 0 (after all other others)
	_InsertMenu		 insert	the new	menu
	move.l	(sp)+,d1	 return	the new	handle
	rts

;****************************************************************
; Get a menu's	handle:
;   P:	d1.w = menu no.
;   R:	(sp).l = the handle

GetMenuHandle
	clr.l	-(sp)		 space for returned handle
	move.w	d1,-(sp)	 menu resource ID
	_GetRMenu		 go get	it
	move.l	(sp)+,d1	 get the handle	off stack
	move.l	(sp)+,a0	 get return address too
	move.l	d1,-(sp)	 restack the handle
	jmp	(a0)		 and return

;****************************************************************
; Unhighlight any highlighted menu title:

UnhighlightMenu
	clr.w	-(sp)
	_HiliteMenu
	rts

;****************************************************************
;

Beep	move.w	#1,-(sp)
	_SysBeep
	movea.l	#120,a0

	_Delay
	rts

;****************************************************************
; Read	a byte from the	input file:
;   R:	d1.b = the byte
;	carry set if any errors

	loc
ReadByte
	lea	DiskParms,a0	 setup ptr to param blk
	lea	ByteBuffer,a1	 specify a buffer
	move.l	a1,ioBuffer
	move.l	#1,ioByteCount	 read one byte at a time

	clr.w	ioPosMode	 relative to current mark
	_Read			 read it

	move.b	ByteBuffer,d1	 return	the byte
	tst.w	d0		 any errors ?
	bne.s	.Err		 yes
	or	d1,d1		 else clear carry
	rts

.Err	ori.b	#1,CCR		 set carry
	rts

;****************************************************************
; Print a character:
;   P:	d1.b = the character

	loc
PrintChar
	move.w	StripLF,d0	 stripping LF's	?
	beq.s	.2		 no
	cmpi.b	#$0A,d1		yes - is it a LF ?
	beq.s	.Exit		 yes - ignore it

.2	cmpi.b	#$09,d1		 is it a tab ?
	bne.s	.8		 no
	move.w	Tabbing,d0	 yes - are we expanding	tabs ?
	beq.s	.8		 no

;Expand tabs to stops on every	8 columns:

.4	move.b	#$20,d1		print a space
	bsr	PrintByte
	move.w	Column,d0	 on an 8th column yet ?
	andi.b	#$07,d0
	bne	.4		 not yet
	bra.s	.Exit		 yes - done

.8	move.w	d1,-(sp)	 save the char a minute
	jsr	PrintByte	 print it
	move.w	(sp)+,d1	 get char back

	cmpi.b	#$0D,d1		is it a CR ?
	bne.s	.Exit		 no
	addq.w	#1,PageLines	 yes - count lines
	clr.w	Column		 reset column no.

	move.w	AddLF,d0	 adding	LF's to	CR's ?
	beq.s	.Exit		 no
	move.b	#$0A,d1		yes - add a LF
	bsr	PrintByte

.Exit	rts

;****************************************************************
; Print a byte:
;   P:	d1.b = the byte

	loc
PrintByte
	lea	PrtOutParms,a0	 setup ptr to param blk
	lea	ByteBuffer,a1	 specify a buffer
	move.l	a1,ioBuffer
	move.b	d1,(a1)		put the byte in the buffer
	move.l	#1,ioByteCount	 write one byte	at a time


	cmpi.b	#$0D,d1		bump column if	not CR or LF
	beq.s	.2
	cmpi.b	#$0A,d1
	beq.s	.2
	addq.w	#1,Column	 else bump column no.

.2	move.w	PortNum,d0
	cmpi.w	#2,d0
	beq.s	OSPRTK
	_Write
	rts

; ==> This stuff in upper case	was added so that List would work
; ==> under the FastFinder. It's not needed under Apple's Finder.
; ==> It goes right to	the SCC	chip to	monitor	the CTS	line because
; ==> characters were dropping	under FastFinder!

OSPRTK	MOVEM.L	D1-D2/A0,-(SP)
	MOVE.L	#$9FFFF8,A0

	MOVE.B	(A0),D2

OSPRT2	ADD.L	#$200001,A0

	MOVE.B	#0,(A0)
	MOVE.W	(A7),(A7)
	MOVE.B	#$10,(A0)
	SUB.L	#$200001,A0

	MOVE.B	(A0),D2		DO WE HAVE CTS	?
	BTST	#5,D2
	BNE.S	OSPRT2		 NO - PRINTER IS BUSY

	MOVE.B	(A0),D2
OSD2	MOVE.W	(A7),(A7)
	MOVE.B	(A0),D2
	BTST	#2,D2		 TX EMPTY ?
	BEQ.S	OSD2		 NO - WAIT

	MOVE.L	A0,-(SP)
	ADD.L	#$200001,A0

	MOVE.B	D1,4(A0)
	MOVE.L	(SP)+,A0

	MOVE.B	(A0),D2		WAIT FOR CHAR TO GET OUT
OSD4	MOVE.W	(A7),(A7)
	MOVE.B	(A0),D2
	BTST	#2,D2
	BEQ.S	OSD4

	MOVE.B	(A0),D2
	MOVEM.L	(SP)+,D1-D2/A0
	RTS

;****************************************************************
; Table of escape codes to ImageWriter	for various styles:

StyleEscapes
	dc.b	$6E,$4E,$45,$70
	dc.b	$50,$65,$71,$51

;****************************************************************
; Initialized data storage area:

ImageWriter	dc.w	$FFFF	 true or false
StyleNum	dc.w	9	 current print style no.

PortNum		dc.w	2	 1 = port A, 2 = port B
AddLF		dc.w	$FFFF	 true or false
StripLF		dc.w	0	 true or false
Paging		dc.w	$FFFF	 pagination - true or false
Tabbing		dc.w	$FFFF	 tab expansion - true or false

;****************************************************************

;This is the resource portion of the LIST application.	It uses
;the in-line resource compiling capabilities of McAsm.

;****************************************************************
;Some equates we'll need:

chk		equ	$12		 check mark char
visible		equ	$FFFF		 true boolean
nogoaway	equ	0		 false boolean

;DITL types:

button		equ	4
statictext	equ	8

;****************************************************************
;Version data is a string whose type is the signature of the
;application -	we have	to define our own resource for this 'cause
;it's a non-standard type:

; ('[[...]]' are McAsm's user defined resource	delimiters.)


[[ LIST,0			ID is 0 by convention,	no attr	or name
	text	#"Lister, V1.1, 7-12-85"
]]

;****************************************************************
;All the rest are standard resource types:

; ('$$' is McAsm's delimiter for a standard resource definition.)

;****************************************************************
;Tell the Finder that we have bundle info in this application:

$$ BNDL,128			 bundle	resc, ID = 128
LIST				 the application's signature again
0				 ID is again 0 by convention
2				 two resc types	in the BNDL list:
ICN#,1				 map one icon list:
0,128				 local ID 0 -> actual ID 128
FREF,1				 map one FREF list:
0,128				 local ID 0 -> actual ID 128

;****************************************************************
;Our bundle's FREF resource:

$$ FREF,128			 FREF resc, ID = 128
APPL				 filetype
0				 local ID for icon list
|				 no filename follows the application

;****************************************************************
;This is our unique desktop icon and it's selected mask. To get
;this to display, we'll have to set the 'bundle bit' in the final
;linked file and then re-init the desktop by holding down the command
;and option keys as we	execute	the Finder. (FEDIT or something
;similar can be used to set the bundle	bit.)

$$ ICN#,128			 an icon list, ID = 128

$00000000,$00000000,$1FE00000,$20100000
$2FD00000,$28500000,$28500000,$2FD00000
$20100000,$3FF00000,$20100000,$21DC3F80
$201460C0,$2014C030,$3FF48018,$000D800C
$01F901E6,$06010323,$1803FFF1,$301E03B1
$20F00E31,$23001839,$33FFF029,$1E00102D
$0200D065,$0200D1C6,$02001301,$02001C00
$03FFF800,$00000000,$3FF80000,$7FF80000
$00000000,$1FF00000,$3FF80000,$7FF80000
$7FF80000,$7FF80000,$7FF80000,$7FF80000
$7FF80000,$7FF80000,$7FFE3F80,$7FFE7FC0
$7FFEFFF0,$7FFFFFF8,$7FFFFFFC,$7FFFFFFE
$07FFFFFF,$1FFFFFFF,$3FFFFFFF,$7FFFFFFF
$7FFFFFFF,$7FFFFFFF,$7FFFFFFF,$3FFFFFFF
$1FFFFFFF,$07FFFFEF,$07FFFFC7,$07FFFF01
$07FFFC00,$07FFF800,$00000000,$00000000

;****************************************************************
;This is our 'About' menu:

$$ MENU,1			 menu ID 1
0,0,0				 placeholders for some stuff
$FFFFFFFB			 enable	mask - item 2 disabled
"/$14"				 menu title = apple char
2				 two items in this menu:
;				 item 1:
About List...			   the menu item
0,0				   no icon, no keybd equivalent
0,0				   no marking char, text style = plain
;				 item 2:
-------------			   the item - draw a disabled line
0,0,0,0			   no icon, no kybd, no	mark, plain text

;This is our 'File' menu:

$$ MENU,2			 menu ID 2
0,0,0				 placeholders for some stuff
$FFFFFFFF			 enable	mask - everything enabled
File				 menu title
2				 two items in this menu:
;				 item 1:
Listing			   the menu item
0,0,0,0			   no icon, no kybd, no	mark, plain text
;				 item 2:
Quit				   the menu item
0,0,0,0			   no icon, no kybd, no	mark, plain text


;****************************************************************
;This is our 'Style' menu:

$$ MENU,3			 menu ID 3
0,0,0				 placeholders for some stuff
$FFFFFFFB			 enable	mask - everything enabled but item 2
Style				 menu title
10				 ten items in this menu:
;				 item 1:
ImageWriter			   the menu item
0,0,chk,0			   no icon, no kybd, check mark, plain text
;				 item 2:
--------------------		   disabled line
0,0,0,0			   no icon, no kybd, no	mark, plain text
;				 item 3:
Extended	72		   the item
0,0,0,0			   nothing special
;				 item 4:
PICA		80
0,0,0,0
;				 item 5:
ELITE		   96
0,0,0,0
;				 item 6:
PICA prop.    --
0,0,0,0
;				 item 7:
ELITE prop.   --
0,0,0,0
;				 item 8:
Semicond.   108
0,0,0,0
;				 item 9:
Condensed  120
0,0,chk,0			   check mark on this one
;				 item 10:
Ultracond.   132
0,0,0,0


;****************************************************************
;This is our 'Options'	menu:

$$ MENU,4			 menu ID 4
0,0,0				 placeholders for some stuff
$FFFFFE97			 enable	mask - 3,5,6,8 disabled
Options			 menu title
9				 nine items in this menu:
;				 item 1:
Port A, modem			   the menu item
0,0,0,0			   no icon, no kybd, no	mark, plain text
;				 item 2:
Port B, printer		   the item
0,0,chk,0			   check mark on this one
;				 item 3:
-------------------		   another disabled line
0,0,0,0			   nothing special
;				 item 4:
Add LFs to CRs			   the item
0,0,chk,0			   another check mark
;				 item 5:
Strip LFs			   this	one's disabled
0,0,0,0
;				 item 6:
-------------------		   another disabled line
0,0,0,0
;				 item 7:
Pagination, 60	lppg		   the item
0,0,chk,0			   and yet another check mark
;				 item 8:
-------------------		   yet another disabled	line
0,0,0,0
;				 item 9:
Expand tabs, 8 spcs
0,0,chk,0			   check mark on this one

;****************************************************************
;This is the 'About' dialog box:

$$ DLOG,1			 dialog, ID = 1
100,100,190,400		 bounds	rectangle
1				 type =	modal dialog box
visible			 initial state
nogoaway			 no close box
0				 refcon
1				 resc ID of DLOG's item	list
|				 no title

$$ DITL,1			 item list for above
3				 three items in	this list:
;				 item 1:
0				   handle holder
15,20,36,300			   display rectangle
statictext			   item	type
All I wanted was a listing...	   the item
;				 item 2:
0				   handle holder
35,20,56,300			   display rectangle
statictext			   item	type
"     By Dave McWherter"	   the item
;				 item 3:
0				   handle holder
60,230,80,290			   display rectangle
button				   item	type
OK				   button's title

;****************************************************************
;This is the 'Change your mind?' dialog box:

$$ DLOG,2			 dialog, ID = 2
100,100,220,235		 bounds	rectangle
1				 type =	modal dialog box
visible			 initial state
nogoaway			 no close box
0				 refcon
2				 resc ID of DLOG's item	list
Change	your mind?		 the title
$$ DITL,2			 item list for above
3				 three items in	this list:
;				 item 1:
0				   handle holder
15,20,35,95			   display rectangle
button				   item	type
Abort				   button's title
;				 item 2:
0				   handle holder
50,20,70,95			   display rectangle
button				   item	type
Pause				   button's title
;				 item 3:
0				   handle holder
85,20,105,95			   display rectangle

button				   item	type
Resume				   button's title


;****************************************************************

	end
